//   ==================================================================
//   >>>>>>>>>>>>>>>>>>>>>>> COPYRIGHT NOTICE <<<<<<<<<<<<<<<<<<<<<<<<<
//   ------------------------------------------------------------------
//   Copyright (c) 2006-2011 by Lattice Semiconductor Corporation
//   ------------------------------------------------------------------
//   ALL RIGHTS RESERVED
//
//   IMPORTANT: THIS FILE IS AUTO-GENERATED BY THE LATTICEMICO SYSTEM.
//
//   Permission:
//
//      Lattice Semiconductor grants permission to use this code
//      pursuant to the terms of the Lattice Semiconductor Corporation
//      Open Source License Agreement.
//
//   Disclaimer:
//
//      Lattice Semiconductor provides no warranty regarding the use or
//      functionality of this code. It is the user's responsibility to
//      verify the users design for consistency and functionality through
//      the use of formal verification methods.
//
//   --------------------------------------------------------------------
//
//                  Lattice Semiconductor Corporation
//                  5555 NE Moore Court
//                  Hillsboro, OR 97214
//                  U.S.A
//
//                  TEL: 1-800-Lattice (USA and Canada)
//                         503-286-8001 (other locations)
//
//                  web: http://www.latticesemi.com/
//                  email: techsupport@latticesemi.com
//
//   --------------------------------------------------------------------
//
//      Project:           platform
//      File:              platform.v
//      Date:              gio, 31 gen 2013 12:17:17 CET
//      Version:           2.1
//      Targeted Family:   All
//
//   =======================================================================

`include "system_conf.v"






module platform_PUR ( 
	clk_i,reset_n
, gpioPIO_OUT
, slave_passthruclk
, slave_passthrurst
, slave_passthruslv_adr
, slave_passthruslv_master_data
, slave_passthruslv_slave_data
, slave_passthruslv_strb
, slave_passthruslv_cyc
, slave_passthruslv_ack
, slave_passthruslv_err
, slave_passthruslv_rty
, slave_passthruslv_sel
, slave_passthruslv_we
, slave_passthruslv_bte
, slave_passthruslv_cti
, slave_passthruslv_lock
, slave_passthruintr_active_high
, pageselPIO_OUT
, SPI_REGclk
, SPI_REGrst
, SPI_REGslv_adr
, SPI_REGslv_master_data
, SPI_REGslv_slave_data
, SPI_REGslv_strb
, SPI_REGslv_cyc
, SPI_REGslv_ack
, SPI_REGslv_err
, SPI_REGslv_rty
, SPI_REGslv_sel
, SPI_REGslv_we
, SPI_REGslv_bte
, SPI_REGslv_cti
, SPI_REGslv_lock
, SPI_REGintr_active_high
, tastiPIO_IN
);	  

input [8-1:0] tastiPIO_IN;

output [8-1:0] pageselPIO_OUT;
input	clk_i, reset_n;
output [4-1:0] gpioPIO_OUT;
output  slave_passthruclk;
output  slave_passthrurst;
output [32-1:0] slave_passthruslv_adr;
output [32-1:0] slave_passthruslv_master_data;
input [32-1:0] slave_passthruslv_slave_data;
output  slave_passthruslv_strb;
output  slave_passthruslv_cyc;
input  slave_passthruslv_ack;
input  slave_passthruslv_err;
input  slave_passthruslv_rty;
output [3:0]  slave_passthruslv_sel;
output  slave_passthruslv_we;
output [1:0]  slave_passthruslv_bte;
output [2:0]  slave_passthruslv_cti;
output  slave_passthruslv_lock;
input  slave_passthruintr_active_high;

wire [31:0] SPI_REGS_DAT_O;
wire   SPI_REGS_ACK_O;
wire   SPI_REGS_ERR_O;
wire   SPI_REGS_RTY_O;
wire SPI_REGS_en;
wire SPI_REGINTR_O;
output  SPI_REGclk;
output  SPI_REGrst;
output [32-1:0] SPI_REGslv_adr;
output [32-1:0] SPI_REGslv_master_data;
input [32-1:0] SPI_REGslv_slave_data;
output  SPI_REGslv_strb;
output  SPI_REGslv_cyc;
input  SPI_REGslv_ack;
input  SPI_REGslv_err;
input  SPI_REGslv_rty;
output [3:0]  SPI_REGslv_sel;
output  SPI_REGslv_we;
output [1:0]  SPI_REGslv_bte;
output [2:0]  SPI_REGslv_cti;
output  SPI_REGslv_lock;
input  SPI_REGintr_active_high;


	GSR GSR_INST (.GSR(1'b1));
	PUR PUR_INST (.PUR(1'b1));
	
platform platform_u ( 
.clk_i(clk_i),
.reset_n(reset_n)
, .gpioPIO_OUT(gpioPIO_OUT) // [4-1:0]
, .slave_passthruclk(slave_passthruclk) // 
, .slave_passthrurst(slave_passthrurst) // 
, .slave_passthruslv_adr(slave_passthruslv_adr) // [32-1:0]
, .slave_passthruslv_master_data(slave_passthruslv_master_data) // [32-1:0]
, .slave_passthruslv_slave_data(slave_passthruslv_slave_data) // [32-1:0]
, .slave_passthruslv_strb(slave_passthruslv_strb) // 
, .slave_passthruslv_cyc(slave_passthruslv_cyc) // 
, .slave_passthruslv_ack(slave_passthruslv_ack) // 
, .slave_passthruslv_err(slave_passthruslv_err) // 
, .slave_passthruslv_rty(slave_passthruslv_rty) // 
, .slave_passthruslv_sel(slave_passthruslv_sel) // [3:0] 
, .slave_passthruslv_we(slave_passthruslv_we) // 
, .slave_passthruslv_bte(slave_passthruslv_bte) // [1:0] 
, .slave_passthruslv_cti(slave_passthruslv_cti) // [2:0] 
, .slave_passthruslv_lock(slave_passthruslv_lock) // 
, .slave_passthruintr_active_high(slave_passthruintr_active_high) // 
, .pageselPIO_OUT(pageselPIO_OUT) // [8-1:0]
, .SPI_REGclk(SPI_REGclk) // 
, .SPI_REGrst(SPI_REGrst) // 
, .SPI_REGslv_adr(SPI_REGslv_adr) // [32-1:0]
, .SPI_REGslv_master_data(SPI_REGslv_master_data) // [32-1:0]
, .SPI_REGslv_slave_data(SPI_REGslv_slave_data) // [32-1:0]
, .SPI_REGslv_strb(SPI_REGslv_strb) // 
, .SPI_REGslv_cyc(SPI_REGslv_cyc) // 
, .SPI_REGslv_ack(SPI_REGslv_ack) // 
, .SPI_REGslv_err(SPI_REGslv_err) // 
, .SPI_REGslv_rty(SPI_REGslv_rty) // 
, .SPI_REGslv_sel(SPI_REGslv_sel) // [3:0] 
, .SPI_REGslv_we(SPI_REGslv_we) // 
, .SPI_REGslv_bte(SPI_REGslv_bte) // [1:0] 
, .SPI_REGslv_cti(SPI_REGslv_cti) // [2:0] 
, .SPI_REGslv_lock(SPI_REGslv_lock) // 
, .SPI_REGintr_active_high(SPI_REGintr_active_high) // 
, .tastiPIO_IN(tastiPIO_IN)
);

endmodule
