library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
entity platform_vhd is
port(
clk_i   : in std_logic
; reset_n : in std_logic
; gpioPIO_OUT : out std_logic_vector(3 downto 0)
; slave_passthruclk : out std_logic
; slave_passthrurst : out std_logic
; slave_passthruslv_adr : out std_logic_vector(31 downto 0)
; slave_passthruslv_master_data : out std_logic_vector(31 downto 0)
; slave_passthruslv_slave_data : in std_logic_vector(31 downto 0)
; slave_passthruslv_strb : out std_logic
; slave_passthruslv_cyc : out std_logic
; slave_passthruslv_ack : in std_logic
; slave_passthruslv_err : in std_logic
; slave_passthruslv_rty : in std_logic
; slave_passthruslv_sel : out std_logic_vector(3 downto 0)
; slave_passthruslv_we : out std_logic
; slave_passthruslv_bte : out std_logic_vector(1 downto 0)
; slave_passthruslv_cti : out std_logic_vector(2 downto 0)
; slave_passthruslv_lock : out std_logic
; slave_passthruintr_active_high : in std_logic
; pageselPIO_OUT : out std_logic_vector(7 downto 0)
; SPI_REGclk : out std_logic
; SPI_REGrst : out std_logic
; SPI_REGslv_adr : out std_logic_vector(31 downto 0)
; SPI_REGslv_master_data : out std_logic_vector(31 downto 0)
; SPI_REGslv_slave_data : in std_logic_vector(31 downto 0)
; SPI_REGslv_strb : out std_logic
; SPI_REGslv_cyc : out std_logic
; SPI_REGslv_ack : in std_logic
; SPI_REGslv_err : in std_logic
; SPI_REGslv_rty : in std_logic
; SPI_REGslv_sel : out std_logic_vector(3 downto 0)
; SPI_REGslv_we : out std_logic
; SPI_REGslv_bte : out std_logic_vector(1 downto 0)
; SPI_REGslv_cti : out std_logic_vector(2 downto 0)
; SPI_REGslv_lock : out std_logic
; SPI_REGintr_active_high : in std_logic
; tastiPIO_IN : in std_logic_vector(7 downto 0)
);
end platform_vhd;

architecture platform_vhd_a of platform_vhd is

component platform
   port(
      clk_i   : in std_logic
      ; reset_n : in std_logic
      ; gpioPIO_OUT : out std_logic_vector(3 downto 0)
      ; slave_passthruclk : out std_logic
      ; slave_passthrurst : out std_logic
      ; slave_passthruslv_adr : out std_logic_vector(31 downto 0)
      ; slave_passthruslv_master_data : out std_logic_vector(31 downto 0)
      ; slave_passthruslv_slave_data : in std_logic_vector(31 downto 0)
      ; slave_passthruslv_strb : out std_logic
      ; slave_passthruslv_cyc : out std_logic
      ; slave_passthruslv_ack : in std_logic
      ; slave_passthruslv_err : in std_logic
      ; slave_passthruslv_rty : in std_logic
      ; slave_passthruslv_sel : out std_logic_vector(3 downto 0)
      ; slave_passthruslv_we : out std_logic
      ; slave_passthruslv_bte : out std_logic_vector(1 downto 0)
      ; slave_passthruslv_cti : out std_logic_vector(2 downto 0)
      ; slave_passthruslv_lock : out std_logic
      ; slave_passthruintr_active_high : in std_logic
      ; pageselPIO_OUT : out std_logic_vector(7 downto 0)
      ; SPI_REGclk : out std_logic
      ; SPI_REGrst : out std_logic
      ; SPI_REGslv_adr : out std_logic_vector(31 downto 0)
      ; SPI_REGslv_master_data : out std_logic_vector(31 downto 0)
      ; SPI_REGslv_slave_data : in std_logic_vector(31 downto 0)
      ; SPI_REGslv_strb : out std_logic
      ; SPI_REGslv_cyc : out std_logic
      ; SPI_REGslv_ack : in std_logic
      ; SPI_REGslv_err : in std_logic
      ; SPI_REGslv_rty : in std_logic
      ; SPI_REGslv_sel : out std_logic_vector(3 downto 0)
      ; SPI_REGslv_we : out std_logic
      ; SPI_REGslv_bte : out std_logic_vector(1 downto 0)
      ; SPI_REGslv_cti : out std_logic_vector(2 downto 0)
      ; SPI_REGslv_lock : out std_logic
      ; SPI_REGintr_active_high : in std_logic
      ; tastiPIO_IN : in std_logic_vector(7 downto 0)
      );
   end component;

begin

lm32_inst : platform
port map (
   clk_i  => clk_i
   ,reset_n  => reset_n
   ,gpioPIO_OUT  => gpioPIO_OUT
   ,slave_passthruclk  => slave_passthruclk
   ,slave_passthrurst  => slave_passthrurst
   ,slave_passthruslv_adr  => slave_passthruslv_adr
   ,slave_passthruslv_master_data  => slave_passthruslv_master_data
   ,slave_passthruslv_slave_data  => slave_passthruslv_slave_data
   ,slave_passthruslv_strb  => slave_passthruslv_strb
   ,slave_passthruslv_cyc  => slave_passthruslv_cyc
   ,slave_passthruslv_ack  => slave_passthruslv_ack
   ,slave_passthruslv_err  => slave_passthruslv_err
   ,slave_passthruslv_rty  => slave_passthruslv_rty
   ,slave_passthruslv_sel  => slave_passthruslv_sel
   ,slave_passthruslv_we  => slave_passthruslv_we
   ,slave_passthruslv_bte  => slave_passthruslv_bte
   ,slave_passthruslv_cti  => slave_passthruslv_cti
   ,slave_passthruslv_lock  => slave_passthruslv_lock
   ,slave_passthruintr_active_high  => slave_passthruintr_active_high
   ,pageselPIO_OUT  => pageselPIO_OUT
   ,SPI_REGclk  => SPI_REGclk
   ,SPI_REGrst  => SPI_REGrst
   ,SPI_REGslv_adr  => SPI_REGslv_adr
   ,SPI_REGslv_master_data  => SPI_REGslv_master_data
   ,SPI_REGslv_slave_data  => SPI_REGslv_slave_data
   ,SPI_REGslv_strb  => SPI_REGslv_strb
   ,SPI_REGslv_cyc  => SPI_REGslv_cyc
   ,SPI_REGslv_ack  => SPI_REGslv_ack
   ,SPI_REGslv_err  => SPI_REGslv_err
   ,SPI_REGslv_rty  => SPI_REGslv_rty
   ,SPI_REGslv_sel  => SPI_REGslv_sel
   ,SPI_REGslv_we  => SPI_REGslv_we
   ,SPI_REGslv_bte  => SPI_REGslv_bte
   ,SPI_REGslv_cti  => SPI_REGslv_cti
   ,SPI_REGslv_lock  => SPI_REGslv_lock
   ,SPI_REGintr_active_high  => SPI_REGintr_active_high
   ,tastiPIO_IN  => tastiPIO_IN
   );

end platform_vhd_a;

