/**************************************************************
 * This example exercises LEDs on LatticeMico32 Development   *
 * board.                                                     *
 *                                                            *
 *                                                            *
 *                                                            *
 *------------------------------------------------------------*
 * PREREQUISITES:                                             *
 *                                                            *                                                                                                    
 * - GPIO with 8-bit output named LED connected to the        *
 *   board's LED pins.                                        *
 **************************************************************/

#include "system_conf.h"

# define RUN_ALL

# define F1_R1_destx 16
# define F1_R1_desty 20
# define F1_R1_sorgx 13
# define F1_R1_sorgy 165
# define F1_R1_dimx 234
# define F1_R1_dimy 175
# define F1_R1_pag 0x80000

# define F1_R2_destx 519
# define F1_R2_desty 29
# define F1_R2_sorgx 258
# define F1_R2_sorgy 168
# define F1_R2_dimx 271
# define F1_R2_dimy 112
# define F1_R2_pag 0x80000
/////////////TASTO DEBUG
# define F2_R1_destx 15
# define F2_R1_desty 15
# define F2_R1_sorgx 258
# define F2_R1_sorgy 283
# define F2_R1_dimx 312
# define F2_R1_dimy 115
# define F2_R1_pag 0x80000

# define F2_R2_destx 14
# define F2_R2_desty 163
# define F2_R2_sorgx 378
# define F2_R2_sorgy 492
# define F2_R2_dimx 208
# define F2_R2_dimy 48
# define F2_R2_pag 0x80000

# define F2_R3_destx 20
# define F2_R3_desty 355
# define F2_R3_sorgx 379
# define F2_R3_sorgy 404
# define F2_R3_dimx 208
# define F2_R3_dimy 79
# define F2_R3_pag 0x80000

# define F2_R4_destx 451
# define F2_R4_desty 11
# define F2_R4_sorgx 537
# define F2_R4_sorgy 166
# define F2_R4_dimx 261
# define F2_R4_dimy 77
# define F2_R4_pag 0x80000

# define F2_R5_destx 598
# define F2_R5_desty 137
# define F2_R5_sorgx 600
# define F2_R5_sorgy 248
# define F2_R5_dimx 194
# define F2_R5_dimy 305
# define F2_R5_pag 0x80000
//////////////TASTO VIDEO
# define F3_R1_destx 13
# define F3_R1_desty 15
# define F3_R1_sorgx 26
# define F3_R1_sorgy 436
# define F3_R1_dimx 227
# define F3_R1_dimy 144
# define F3_R1_pag 0x80000
          
# define F3_R2_destx 38
# define F3_R2_desty 348
# define F3_R2_sorgx 38
# define F3_R2_sorgy 347
# define F3_R2_dimx 158
# define F3_R2_dimy 79
# define F3_R2_pag 0x80000
          
# define F3_R3_destx 521
# define F3_R3_desty 19
# define F3_R3_sorgx 529
# define F3_R3_sorgy 374
# define F3_R3_dimx 253
# define F3_R3_dimy 76
# define F3_R3_pag 0x100000
          
# define F3_R4_destx 532
# define F3_R4_desty 324
# define F3_R4_sorgx 537
# define F3_R4_sorgy 467
# define F3_R4_dimx 251
# define F3_R4_dimy 114
# define F3_R4_pag 0x100000
////////////////////TASTO ETHERNET
# define F4_R1_destx 18
# define F4_R1_desty 14
# define F4_R1_sorgx 19
# define F4_R1_sorgy 12
# define F4_R1_dimx 295
# define F4_R1_dimy 148
# define F4_R1_pag 0x100000
          
# define F4_R2_destx 25
# define F4_R2_desty 366
# define F4_R2_sorgx 19
# define F4_R2_sorgy 282
# define F4_R2_dimx 225
# define F4_R2_dimy 83
# define F4_R2_pag 0x100000
          
# define F4_R3_destx 566
# define F4_R3_desty 20
# define F4_R3_sorgx 18
# define F4_R3_sorgy 373
# define F4_R3_dimx 216
# define F4_R3_dimy 115
# define F4_R3_pag 0x100000
          
# define F4_R4_destx 554
# define F4_R4_desty 317
# define F4_R4_sorgx 16
# define F4_R4_sorgy 165
# define F4_R4_dimx 231
# define F4_R4_dimy 112
# define F4_R4_pag 0x100000
////////////////////TASTO MEMORY
# define F5_R1_destx 18
# define F5_R1_desty 60
# define F5_R1_sorgx 510
# define F5_R1_sorgy 177
# define F5_R1_dimx 266
# define F5_R1_dimy 110
# define F5_R1_pag 0x100000
         
# define F5_R2_destx 434
# define F5_R2_desty 20
# define F5_R2_sorgx 433
# define F5_R2_sorgy 18
# define F5_R2_dimx 347
# define F5_R2_dimy 50
# define F5_R2_pag 0x100000
          
# define F5_R3_destx 499
# define F5_R3_desty 360
# define F5_R3_sorgx 561
# define F5_R3_sorgy 89
# define F5_R3_dimx 222
# define F5_R3_dimy 79
# define F5_R3_pag 0x100000


////////////////////////////////// GRAFICA

#define COLOR		unsigned short
void PUT_PIXEL(int X,int Y,int C)
{
*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + 0x180000) + ((Y)*800) + X))= (unsigned short) C;
}

static void bresenham_circle(int c_x, int c_y, int radius,  COLOR color)
{
	int x, y;
	int dx, dy;
	int error;
	//volatile char* c_vid = C_VIDEO_MEMORY;

	x = radius;
	y = 0;
	dx = 1 - (radius << 1);
	dy = 1;
	error = 0;

	while(x >= y){
		/* plot points */
		int x_spot, y_spot;

		x_spot = c_x + x;
		y_spot = c_y + y;
		//c_vid[(y_spot*C_NUM_PIXELS_PER_LINE) + x_spot] = pix_val;
		PUT_PIXEL(x_spot, y_spot, color);

		x_spot = c_x - x;
		//c_vid[((y_spot)*C_NUM_PIXELS_PER_LINE) + x_spot] = pix_val;
		PUT_PIXEL(x_spot, y_spot, color);

		y_spot = c_y - y;
		//c_vid[((y_spot)*C_NUM_PIXELS_PER_LINE) + x_spot] = pix_val;
		PUT_PIXEL(x_spot, y_spot, color);

		x_spot = c_x + x;
		//c_vid[((y_spot)*C_NUM_PIXELS_PER_LINE) + x_spot] = pix_val;
		PUT_PIXEL(x_spot, y_spot, color);

		x_spot = c_x + y;
		y_spot = c_y + x;
		//c_vid[((y_spot)*C_NUM_PIXELS_PER_LINE) + x_spot] = pix_val;
		PUT_PIXEL(x_spot, y_spot, color);

		x_spot = c_x - y;
		//c_vid[((y_spot)*C_NUM_PIXELS_PER_LINE) + x_spot] = pix_val;
		PUT_PIXEL(x_spot, y_spot, color);

		y_spot = c_y - x;
		//c_vid[((y_spot)*C_NUM_PIXELS_PER_LINE) + x_spot] = pix_val;
		PUT_PIXEL(x_spot, y_spot, color);

		x_spot = c_x + y;
		//c_vid[((y_spot)*C_NUM_PIXELS_PER_LINE) + x_spot] = pix_val;
		PUT_PIXEL(x_spot, y_spot, color);

		y++;
		error += dy;
		dy += 2;
		if( ((error << 1)+dx) > 0){
			x--;
			error += dx;
			dx+=2;
		}
	}
}


/*
 * Function to draw a circle
 */
void c_draw_circle(int c_x, int c_y, int radius, COLOR color)
{
	bresenham_circle(c_x, c_y, radius, color);
}






void attesa_1 (int s)
{
	int j, k;
	for (k=0; k<s; k++)
		for (j=0; j<1000; )
			j++;
}


void attesa_2 (int s)
{
	int j, k;
	for (k=0; k<s; k++)
		for (j=0; j<10; )
			j++;
}

//---------------------------------------------------------------------------
int Copy (int src_page_addr, int x, int y, int X, int Y, int dst_page_addr, int tox, int toy)
// src_page_addr = indirizzo iniziale della pagina sorgente (che contiene l'icona da copiare)
// x, y = vertice sup sx dell'icona sorgente
// X, Y = dimensioni in num_colonne e num_righe della icona sorgente
// dst_page_addr = indirizzo iniziale della pagina di destinazione (su cui l'icona viene copiata)
// tox, toy = vertice sup sx dell'icona destinazione
{
	int h, k;
	for (k=0; k<X; k++)
		for (h=0; h<Y; h++)
		{
			*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + dst_page_addr) + (((toy+h)*800) + k + tox)))= *((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + src_page_addr) + (((y+h)*800) + k + x)));
		}
	return 0;
}



int copia_da_pag (int ind_dest, int x, int y, int X, int Y, int ind_pag, int tox, int toy)
//ind_dest = indirizzo della pagina su cui copio
// x, y = vertice sup sx dell'icona sorgente
// X, Y = dimensioni in colonna e riga della icona da copiare
// ind_pag = indirizzo della pag destinazione
// tox , toy = vertice sup sx dell'icona destinazione
{
	int h, k;
	for (k=0; k<X; k++)
		for (h=0; h<Y; h++)
		{
		*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + ind_dest) + (((toy+h)*800) + k + tox)))= *((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + ind_pag) + (((y+h)*800) + k + x)));
		}
return 0;
}

//---------------------------------------------------------------------------
//

int copia_da_pag_trasp_vert (int ind_dest, int x, int y, int X, int Y, int ind_pag, int tox, int toy)
{
	int h, k;
	unsigned short temp ;
	for (h=0; h<Y; h++)
	for (k=0; k<X; k++)
		//for (h=0; h<Y; h++)
		{
			temp = *((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + ind_pag) + (((y+h)*800) + k + x)));
			if (temp != 0xFFFF)
				*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + ind_dest) + (((toy+h)*800) + k + tox))) = temp;
		}
	return 0;
}

int copia_da_pag_trasp (int ind_dest, int x, int y, int X, int Y, int ind_pag, int tox, int toy)
{
	int h, k;
	unsigned short temp ;

	for (k=0; k<X; k++)
		for (h=0; h<Y; h++)
		{
			temp = *((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + ind_pag) + (((y+h)*800) + k + x)));
			if (temp != 0xFFFF)
				*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + ind_dest) + (((toy+h)*800) + k + tox))) = temp;
		}
	return 0;
}


int Fill (int page_dest, int X, int Y, int tox, int toy, short col)
// page_dest = indirizzo della pagina di destinazione
// X, Y = dimensioni in num_colonne e num_righe del rettangolo da riempire
// tox , toy = vertice sup sx dell'icona destinazione
// col = colore (16 bit formato rgb565)
{
	int h, k;
	for (k = 0; k < X; k++)
		for (h = 0; h < Y; h++)
		{
			*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + page_dest) + (((toy+h)*800) + k + tox))) = col;
		}
	return 0;
}


void FillNew (int dst_page_addr, int tox, int toy, int dimX, int dimY, short col)
// page_dest = indirizzo della pagina di destinazione
// tox , toy = vertice sup sx dell'icona destinazione
// X, Y = dimensioni in num_colonne e num_righe del rettangolo da riempire
// col = colore (16 bit formato rgb565)
{
	int h, k;
	for (k = 0; k < dimX; k++) {
		for (h = 0; h < dimY; h++) {
			*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + dst_page_addr) + (((toy+h)*800) + k + tox))) = col;
		}
	}
}

void FillNew_vert (int dst_page_addr, int tox, int toy, int dimX, int dimY, short col)
// page_dest = indirizzo della pagina di destinazione
// tox , toy = vertice sup sx dell'icona destinazione
// X, Y = dimensioni in num_colonne e num_righe del rettangolo da riempire
// col = colore (16 bit formato rgb565)
{
	int h, k;
	for (h = 0; h < dimY; h++)
	for (k = 0; k < dimX; k++)

			*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + dst_page_addr) + (((toy+h)*800) + k + tox))) = col;

}


//---------------------------------------------------------------------------
void ReplaceColor (int dst_page_addr, int tox, int toy, int X, int Y, short old_col, short new_col)
{
	int h, k;
	unsigned short temp ;
	for (k=0; k<X; k++) {
		for (h=0; h<Y; h++)
		{
			temp = *((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + dst_page_addr) + (((toy+h)*800) + k + tox)));
//			if (temp != 0xFFFF)
//				*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + ind_dest) + (((toy+h)*800) + k + tox))) = temp;
			if (temp == old_col) {
				*((volatile unsigned short *)((SLAVE_PASSTHRU_BASE_ADDRESS + dst_page_addr) + (((toy+h)*800) + k + tox))) =  new_col;
			}
		}
	}
}



//***************************************************************************
//***************************************************************************

int main(void)
{
unsigned int i;
unsigned int tasto = 1;
unsigned int tasto_old = 1;


unsigned int aa =0xFFFFFFFF;
unsigned int bb =0xFFFFFFFF;


    i = 0;
    *((volatile unsigned char *)(GPIO_BASE_ADDRESS)) = 0xFF;
    attesa_1(1000);
    attesa_1(1000);
    *((volatile unsigned char *)(PAGESEL_BASE_ADDRESS))= 0x0;
    *((volatile unsigned char *)(GPIO_BASE_ADDRESS)) = 0x99;	// USARE SEMPRE X ABILITARE ACCESSO IN MEMORIA
    attesa_1(1000);
////////////////////////// FINE FASE INIZIALE
#ifdef RUN_ALL

    while(aa != 0x0) {
    	aa = *(volatile unsigned char *) TASTI_BASE_ADDRESS;
// sinistra
    copia_da_pag_trasp_vert ( 0x0, 8, 8, 212, 138, 0x80000, 330, 120); // disegna mano sinistra
    copia_da_pag_trasp ( 0x0, 414, 7, 163, 64, 0x80000, 363, 45); //scrive left
    attesa_1 (800);
    FillNew (0x0, 363, 45, 163, 64,0xFFFF);// cancella left
    FillNew_vert (0x0, 330, 120, 212, 138,0xFFFF);// cancella mano
    attesa_1 (100);

    copia_da_pag_trasp ( 0x0, 8, 8, 212, 138, 0x80000, 434, 120); // disegna mano destra (1)
    copia_da_pag_trasp_vert ( 0x0, 588, 7, 213, 61, 0x80000, 421, 45); //scrive right
    attesa_1 (800);
    FillNew (0x0, 421, 45, 213, 61,0xFFFF);// cancella right
    FillNew_vert (0x0, 434, 120, 212, 138,0xFFFF);// cancella mano (1)
    attesa_1 (100);

    copia_da_pag_trasp_vert ( 0x0, 8, 8, 212, 138, 0x80000, 380, 120); // disegna mano centrale (1)
    copia_da_pag_trasp_vert ( 0x0, 560, 87, 238, 62, 0x80000, 363, 45); //scrive select
    attesa_1 (800);
    FillNew_vert (0x0, 363, 45, 238, 62,0xFFFF);// cancella select
    FillNew (0x0, 380, 120, 212, 138,0xFFFF);// cancella mano
    attesa_1 (100);
    }
#endif
/////////////////// uscita programma demo manine
// vai a pagina 0x3 e seleziona primo tasto
    *((volatile unsigned char *)(PAGESEL_BASE_ADDRESS))= 0x3;
     ReplaceColor (0x180000, 48,455, 142,139, 0x0, 0xF800);
     attesa_1 (100);
    while(1)
    {

    	aa = *(volatile unsigned char *) TASTI_BASE_ADDRESS;
    	if (aa==0x3)// significa destra
    	{
    		if (tasto == 5)
    		{	tasto = 1;
    			ReplaceColor (0x180000, 610,455, 142,139, 0xF800, 0x0);    //tasto5 --> nero
    			ReplaceColor (0x180000, 48 ,455, 142,139, 0x0   , 0xF800); //tasto1 --> rosso
    		}
    		else
    		{	tasto = tasto + 1;
    			ReplaceColor (0x180000, (48+(142*(tasto-2))),455, 142,139, 0xF800, 0x0); //tasto-1 --> nero
    			ReplaceColor (0x180000, (48+(142*(tasto-1))),455, 142,139, 0x0, 0xF800); //tasto --> rosso
    		}
    	}
    	if (aa==0x6) //significa sinistra
    	{
    		if (tasto == 1)
    		{  	tasto = 5;
    			ReplaceColor (0x180000, 48,455, 142,139, 0xF800, 0x0); //tasto1 --> nero
    			ReplaceColor (0x180000, 610,455, 142,139, 0x0, 0xF800); //tasto5 --> rosso
    		}
    		else
    		{  	tasto = tasto -1;
    			ReplaceColor (0x180000, (48+(142*(tasto))),455, 142,139, 0xF800, 0x0); //tasto+1 --> nero
    		    ReplaceColor (0x180000, (48+(142*(tasto-1)))  ,455, 142,139, 0x0, 0xF800); //tasto --> rosso
    		}
    	}
    	

    	//aa = *(volatile unsigned char *) TASTI_BASE_ADDRESS;
    	//bb = *(volatile unsigned char *) TASTI_BASE_ADDRESS;

    	if ((aa == 0x5)  ) //significa select
    	{

			if (tasto_old ==  1)
    		{
				FillNew_vert (0x180000, F1_R1_destx, F1_R1_desty, F1_R1_dimx, F1_R1_dimy, 0xFFFF);
				FillNew_vert (0x180000, F1_R2_destx, F1_R2_desty, F1_R2_dimx, F1_R2_dimy, 0xFFFF);
			}
    		if (tasto_old ==  2)
    		{
				FillNew_vert (0x180000, F2_R1_destx, F2_R1_desty, F2_R1_dimx, F2_R1_dimy, 0xFFFF);
				FillNew_vert (0x180000, F2_R2_destx, F2_R2_desty, F2_R2_dimx, F2_R2_dimy, 0xFFFF);
				FillNew_vert (0x180000, F2_R3_destx, F2_R3_desty, F2_R3_dimx, F2_R3_dimy, 0xFFFF);
				FillNew_vert (0x180000, F2_R4_destx, F2_R4_desty, F2_R4_dimx, F2_R4_dimy, 0xFFFF);
				FillNew_vert (0x180000, F2_R5_destx, F2_R5_desty, F2_R5_dimx, F2_R5_dimy, 0xFFFF);
			}
			if (tasto_old ==  3)
    		{
				FillNew_vert (0x180000, F3_R1_destx, F3_R1_desty, F3_R1_dimx, F3_R1_dimy, 0xFFFF);
				FillNew_vert (0x180000, F3_R2_destx, F3_R2_desty, F3_R2_dimx, F3_R2_dimy, 0xFFFF);
				FillNew_vert (0x180000, F3_R3_destx, F3_R3_desty, F3_R3_dimx, F3_R3_dimy, 0xFFFF);
				FillNew_vert (0x180000, F3_R4_destx, F3_R4_desty, F3_R4_dimx, F3_R4_dimy, 0xFFFF);
			}
			if (tasto_old ==  4)
    		{
				FillNew_vert (0x180000, F4_R1_destx, F4_R1_desty, F4_R1_dimx, F4_R1_dimy, 0xFFFF);
				FillNew_vert (0x180000, F4_R2_destx, F4_R2_desty, F4_R2_dimx, F4_R2_dimy, 0xFFFF);
				FillNew_vert (0x180000, F4_R3_destx, F4_R3_desty, F4_R3_dimx, F4_R3_dimy, 0xFFFF);
				FillNew_vert (0x180000, F4_R4_destx, F4_R4_desty, F4_R4_dimx, F4_R4_dimy, 0xFFFF);
			}
			if (tasto_old ==  5)
    		{
				FillNew_vert (0x180000, F5_R1_destx, F5_R1_desty, F5_R1_dimx, F5_R1_dimy, 0xFFFF);
				FillNew_vert (0x180000, F5_R2_destx, F5_R2_desty, F5_R2_dimx, F5_R2_dimy, 0xFFFF);
				FillNew_vert (0x180000, F5_R3_destx, F5_R3_desty, F5_R3_dimx, F5_R3_dimy, 0xFFFF);
			}

    		tasto_old = tasto;

    		if (tasto ==  1)
    		{
				copia_da_pag_trasp_vert ( 0x180000, F1_R1_sorgx, F1_R1_sorgy, F1_R1_dimx, F1_R1_dimy, F1_R1_pag, F1_R1_destx, F1_R1_desty);
				copia_da_pag_trasp_vert ( 0x180000, F1_R2_sorgx, F1_R2_sorgy, F1_R2_dimx, F1_R2_dimy, F1_R2_pag, F1_R2_destx, F1_R2_desty);
			}
    		if (tasto ==  2)
			{
				copia_da_pag_trasp_vert ( 0x180000, F2_R1_sorgx, F2_R1_sorgy, F2_R1_dimx, F2_R1_dimy, F2_R1_pag, F2_R1_destx, F2_R1_desty);
				copia_da_pag_trasp_vert ( 0x180000, F2_R2_sorgx, F2_R2_sorgy, F2_R2_dimx, F2_R2_dimy, F2_R2_pag, F2_R2_destx, F2_R2_desty);
				copia_da_pag_trasp_vert ( 0x180000, F2_R3_sorgx, F2_R3_sorgy, F2_R3_dimx, F2_R3_dimy, F2_R3_pag, F2_R3_destx, F2_R3_desty);
				copia_da_pag_trasp_vert ( 0x180000, F2_R4_sorgx, F2_R4_sorgy, F2_R4_dimx, F2_R4_dimy, F2_R4_pag, F2_R4_destx, F2_R4_desty);
				copia_da_pag_trasp_vert ( 0x180000, F2_R5_sorgx, F2_R5_sorgy, F2_R5_dimx, F2_R5_dimy, F2_R5_pag, F2_R5_destx, F2_R5_desty);
			}
			if (tasto ==  3)
			{
				copia_da_pag_trasp_vert ( 0x180000, F3_R1_sorgx, F3_R1_sorgy, F3_R1_dimx, F3_R1_dimy, F3_R1_pag, F3_R1_destx, F3_R1_desty);
				copia_da_pag_trasp_vert ( 0x180000, F3_R2_sorgx, F3_R2_sorgy, F3_R2_dimx, F3_R2_dimy, F3_R2_pag, F3_R2_destx, F3_R2_desty);
				copia_da_pag_trasp_vert ( 0x180000, F3_R3_sorgx, F3_R3_sorgy, F3_R3_dimx, F3_R3_dimy, F3_R3_pag, F3_R3_destx, F3_R3_desty);
				copia_da_pag_trasp_vert ( 0x180000, F3_R4_sorgx, F3_R4_sorgy, F3_R4_dimx, F3_R4_dimy, F3_R4_pag, F3_R4_destx, F3_R4_desty);
			}
			if (tasto ==  4)
			{
				copia_da_pag_trasp_vert ( 0x180000, F4_R1_sorgx, F4_R1_sorgy, F4_R1_dimx, F4_R1_dimy, F4_R1_pag, F4_R1_destx, F4_R1_desty);
				copia_da_pag_trasp_vert ( 0x180000, F4_R2_sorgx, F4_R2_sorgy, F4_R2_dimx, F4_R2_dimy, F4_R2_pag, F4_R2_destx, F4_R2_desty);
				copia_da_pag_trasp_vert ( 0x180000, F4_R3_sorgx, F4_R3_sorgy, F4_R3_dimx, F4_R3_dimy, F4_R3_pag, F4_R3_destx, F4_R3_desty);
				copia_da_pag_trasp_vert ( 0x180000, F4_R4_sorgx, F4_R4_sorgy, F4_R4_dimx, F4_R4_dimy, F4_R4_pag, F4_R4_destx, F4_R4_desty);
			}
			if (tasto ==  5)
			{
				copia_da_pag_trasp_vert ( 0x180000, F5_R1_sorgx, F5_R1_sorgy, F5_R1_dimx, F5_R1_dimy, F5_R1_pag, F5_R1_destx, F5_R1_desty);
				copia_da_pag_trasp_vert ( 0x180000, F5_R2_sorgx, F5_R2_sorgy, F5_R2_dimx, F5_R2_dimy, F5_R2_pag, F5_R2_destx, F5_R2_desty);
				copia_da_pag_trasp_vert ( 0x180000, F5_R3_sorgx, F5_R3_sorgy, F5_R3_dimx, F5_R3_dimy, F5_R3_pag, F5_R3_destx, F5_R3_desty);
			}
    	}
		
		while ( aa != 0x7)
    	{
    		aa = *(volatile unsigned char *) TASTI_BASE_ADDRESS;
    	}



    }
	return(0);

}


