/*
 * Symbol.h
 *
 *  Created on: 12/apr/2013
 *      Author: Enrico
 */

#ifndef SYMBOL_H_
#define SYMBOL_H_


//
// Global definitions
//
#define LCD_DIM_X	800			// Number of horizontal pixels
#define LCD_DIM_Y	600			// Number of vertical pixels
#define LCD_NUM_HOR_PIXELS	LCD_DIM_X
#define LCD_NUM_VER_PIXELS	LCD_DIM_Y

//
// Ram Page start addresses
//
#define PAGE_0					0x00000
#define PAGE_1					0x80000		// ERA 0x100000
#define PAGE_2					0x100000
#define PAGE_3					0x180000
#define PAGE_4					0x200000
#define PAGE_5					0x280000
#define PAGE_6					0x300000
#define PAGE_7					0x380000
#define PAGE_LENGTH				0x80000		// Page length in 16-bit words

//
// Status Icons
// All values are in [pixel]
//
#define STATUS_ICON_X			66		// Status icon width
#define STATUS_ICON_Y			41		// Status icon height
#define STATUS_ICON_X_Y			STATUS_ICON_X, STATUS_ICON_Y	// Status icon width // 070513 ADDED FOR SIMPLIFICATION

// Top-Left corner coordinates
#if 0
#define STATUS_ICON1_x			78
#define STATUS_ICON2_x			161
#define STATUS_ICON3_x			243
#define STATUS_ICON4_x			326
#define STATUS_ICON5_x			409
#define STATUS_ICON6_x			491
#define STATUS_ICON7_x			574
#define STATUS_ICON8_x			657

#define STATUS_ICON1_y			23
#define STATUS_ICON2_y			23
#define STATUS_ICON3_y			23
#define STATUS_ICON4_y			23
#define STATUS_ICON5_y			23
#define STATUS_ICON6_y			23
#define STATUS_ICON7_y			23
#define STATUS_ICON8_y			23
#endif

//						  x,   y			// 070513 AGGIUNTE DEFINIZIONI PER SEMPLIFICARE
#define STATUS_ICON1	 78,  23
#define STATUS_ICON2	161,  23
#define STATUS_ICON3	243,  23
#define STATUS_ICON4	326,  23
#define STATUS_ICON5	409,  23
#define STATUS_ICON6	491,  23
#define STATUS_ICON7	574,  23
#define STATUS_ICON8	657,  23

//
// Button frames
// All values are in [pixel]
//

#define FRAME_X			79		// Button frame width
#define FRAME_Y			64		// Button frame height
#define FRAME_X_Y		FRAME_X, FRAME_Y	// Button frame dimensions // 070513 ADDED FOR SIMPLIFICATION

#define FRAME_THICKNESS	3		// Frame thickness

#define FRAME_SELECTED_COLOR	0x07a0		// Green [RGB565]
#define FRAME_UNSELECTED_COLOR	0xb5d7		// Grey  [RGB565]

// Top-Left coordinates
#if 0
#define FRAME_P1_x		20
#define FRAME_P2_x		117
#define FRAME_P3_x		214
#define FRAME_P4_x		312
#define FRAME_P5_x		409
#define FRAME_P6_x		507
#define FRAME_P7_x		604
#define FRAME_P8_x		702

#define FRAME_P1_y		514
#define FRAME_P2_y		514
#define FRAME_P3_y		514
#define FRAME_P4_y		514
#define FRAME_P5_y		514
#define FRAME_P6_y		514
#define FRAME_P7_y		514
#define FRAME_P8_y		514
#endif

//						  x,   y			// 070513 AGGIUNTE DEFINIZIONI PER SEMPLIFICARE
#define FRAME_P1		 20, 514 	// P1
#define FRAME_P2		117, 514	// P2
#define FRAME_P3		214, 514	// P3
#define FRAME_P4		312, 514	// P4
#define FRAME_P5		409, 514	// P5
#define FRAME_P6		507, 514	// P6
#define FRAME_P7		604, 514	// P7
#define FRAME_P8		702, 514	// P8

// Complete parameter definitions
#define FRAME_P1_SELECTED	FRAME_P1, FRAME_X_Y, FRAME_THICKNESS, FRAME_SELECTED_COLOR
#define FRAME_P2_SELECTED	FRAME_P2, FRAME_X_Y, FRAME_THICKNESS, FRAME_SELECTED_COLOR
#define FRAME_P3_SELECTED	FRAME_P3, FRAME_X_Y, FRAME_THICKNESS, FRAME_SELECTED_COLOR
#define FRAME_P4_SELECTED	FRAME_P4, FRAME_X_Y, FRAME_THICKNESS, FRAME_SELECTED_COLOR
#define FRAME_P5_SELECTED	FRAME_P5, FRAME_X_Y, FRAME_THICKNESS, FRAME_SELECTED_COLOR
#define FRAME_P6_SELECTED	FRAME_P6, FRAME_X_Y, FRAME_THICKNESS, FRAME_SELECTED_COLOR
#define FRAME_P7_SELECTED	FRAME_P7, FRAME_X_Y, FRAME_THICKNESS, FRAME_SELECTED_COLOR
#define FRAME_P8_SELECTED	FRAME_P8, FRAME_X_Y, FRAME_THICKNESS, FRAME_SELECTED_COLOR

#define FRAME_P1_UNSELECTED	FRAME_P1, FRAME_X_Y, FRAME_THICKNESS, FRAME_UNSELECTED_COLOR
#define FRAME_P2_UNSELECTED	FRAME_P2, FRAME_X_Y, FRAME_THICKNESS, FRAME_UNSELECTED_COLOR
#define FRAME_P3_UNSELECTED	FRAME_P3, FRAME_X_Y, FRAME_THICKNESS, FRAME_UNSELECTED_COLOR
#define FRAME_P4_UNSELECTED	FRAME_P4, FRAME_X_Y, FRAME_THICKNESS, FRAME_UNSELECTED_COLOR
#define FRAME_P5_UNSELECTED	FRAME_P5, FRAME_X_Y, FRAME_THICKNESS, FRAME_UNSELECTED_COLOR
#define FRAME_P6_UNSELECTED	FRAME_P6, FRAME_X_Y, FRAME_THICKNESS, FRAME_UNSELECTED_COLOR
#define FRAME_P7_UNSELECTED	FRAME_P7, FRAME_X_Y, FRAME_THICKNESS, FRAME_UNSELECTED_COLOR
#define FRAME_P8_UNSELECTED	FRAME_P8, FRAME_X_Y, FRAME_THICKNESS, FRAME_UNSELECTED_COLOR


///#define FRAME_Pn_y		514		// Generic definition (not recommended)

//
// Pushbuttons
// All values are in [pixel]
//

#define BUTTON_X		70		// Button width
#define BUTTON_Y		56		// Button height
#define BUTTON_X_Y		BUTTON_X, BUTTON_Y	// Button width // 070513 ADDED FOR SIMPLIFICATION

// Top-Left corner coordinates
#if 0
#define BUTTON1_x		24		// P1
#define BUTTON2_x		121		// P2
#define BUTTON3_x		219		// P3
#define BUTTON4_x		316		// P4
#define BUTTON5_x		414		// P5
#define BUTTON6_x		511		// P6
#define BUTTON7_x		609		// P7
#define BUTTON8_x		706		// P8

#define BUTTON1_y		518		// P1
#define BUTTON2_y		518		// P2
#define BUTTON3_y		518		// P3
#define BUTTON4_y		518		// P4
#define BUTTON5_y		518		// P5
#define BUTTON6_y		518		// P6
#define BUTTON7_y		518		// P7
#define BUTTON8_y		518		// P8
#endif

//						  x,   y			// 070513 AGGIUNTE DEFINIZIONI PER SEMPLIFICARE
#define BUTTON1			 24, 518	// P1
#define BUTTON2			121, 518	// P2
#define BUTTON3			219, 518	// P3
#define BUTTON4			316, 518	// P4
#define BUTTON5			414, 518	// P5
#define BUTTON6			511, 518	// P6
#define BUTTON7			609, 518	// P7
#define BUTTON8			706, 518	// P8

//
// Balancing weight positions
//
//  --+                                    +--
//  1 |                                    |5
//    +-----------------+         +--------+
//     2                +-----+---+       4
//                          3 |
//                            |
//                        7   |
//     6                +-----+---+
//    +-----------------+         +--------+
//    |                                    |
//  --+                                    +--
//
// STD =  1 - 5		ALU4 = 1 - 4
// ALU1 = 2 - 4		ALU5 = 2 - 5
// ALU2 = 2 - 3		ALS1 = 1 - 7
// ALU3 = 1 - 3		ALS2 = 6 - 7

#if 0
#define POS_PESO1_x		343		// Peso "1"
#define POS_PESO2_x		361		// Peso "2"
#define POS_PESO3_x		392		// Peso "3"
#define POS_PESO4_x		429		// Peso "4"
#define POS_PESO5_x		446		// Peso "5"
#define POS_PESO6_x		361		// Peso "6"
#define POS_PESO7_x		392		// Peso "7"

#define POS_PESO1_y		187		// Peso "1"
#define POS_PESO2_y		199		// Peso "2"
#define POS_PESO3_y		210		// Peso "3"
#define POS_PESO4_y		199		// Peso "4"
#define POS_PESO5_y		187		// Peso "5"
#define POS_PESO6_y		330		// Peso "6"
#define POS_PESO7_y		319		// Peso "7"
#endif

#define PESI_X			14		// Balancing weight width
#define PESI_Y			14		// Balancing weight height
#define PESI_X_Y		PESI_X, PESI_Y	// Balancing weight // 070513 ADDED FOR SIMPLIFICATION

//						  x,   y			// 070513 AGGIUNTE DEFINIZIONI PER SEMPLIFICARE
#define POS_PESO1		343, 187
#define POS_PESO2		361, 199
#define POS_PESO3		392, 210
#define POS_PESO4		429, 199
#define POS_PESO5		446, 187
#define POS_PESO6		361, 330
#define POS_PESO7		392, 319

//
// Imbalance weight destination coordinates
// IW = Inner Weight (peso interno) on Left display,
// OW = Outer Weight (peso esterno) on Right display,
// FP = floating point
//							  		  x, y
#define COORD_OW_1					719, 230	// Units, OW
#define COORD_OW_10					661, 230	// Tens, OW
#define COORD_OW_100				603, 230	// Hundreds, OW

#define COORD_IW_1					141, 230	// Units, IW
#define COORD_IW_10			 		 83, 230	// Tens, IW
#define COORD_IW_100		 		 25, 230	// Hundreds, IW

#define COORD_OW_FP_10				706, 309	// Floating point, tens, OW
#define COORD_OW_FP_100				648, 309	// Floating point, hundreds, OW

#define COORD_IW_FP_10				128, 309	// Floating point, tens, IW
#define COORD_IW_FP_100		 	 	70,  309	// Floating point, hundreds, IW

#define COORD_OW_FP_10_BLANK		706, 309	// Floating point blank, tens, OW
#define COORD_OW_FP_100_BLANK		648, 309	// Floating point blank, hundreds, OW

#define COORD_IW_FP_10_BLANK		128, 309	// Floating point blank, tens, OW
#define COORD_IW_FP_100_BLANK	 	70,  309	// Floating point blank, hundreds, OW

//
// Numbers: big font (used to display imbalance)
//

//							 x, y
#define BIG_NUMBER_DIM		56, 79
#define BIG_NUMBER_FP_DIM	12, 11

// Big font numbers: src_page top-left coordinates
//							  x, y
#define BIG_NUMBER_0		256, 0
#define BIG_NUMBER_1		314, 0
#define BIG_NUMBER_2		372, 0
#define BIG_NUMBER_3		430, 0
#define BIG_NUMBER_4		488, 0
#define BIG_NUMBER_5		546, 0
#define BIG_NUMBER_6		604, 0
#define BIG_NUMBER_7		662, 0
#define BIG_NUMBER_8		720, 0
#define BIG_NUMBER_9		662, 82
#define BIG_NUMBER_BLANK	314, 0

#define BIG_NUMBER_FP		242, 6
#define BIG_NUMBER_FP_BLANK	242, 19


//
// Wheel dimension destination coordinates
//
//							  		  x, y
#define COORD_DIS_1					617, 134	// Units, Distance
#define COORD_DIS_10				596, 134	// Tens, Distance
#define COORD_DIS_100				575, 134	// Hundreds, Distance

#define COORD_LAR_1					691, 134	// Units, Width
#define COORD_LAR_10			 	670, 134	// Tens, Width
#define COORD_LAR_100		 		649, 134	// Hundreds, Width

#define COORD_DIA_1					765, 134	// Units, Diameter
#define COORD_DIA_10			 	744, 134	// Tens, Diameter
#define COORD_DIA_100		 		723, 134	// Hundreds, Diameter

#define COORD_DIS_FP_10				612, 164	// Floating point, tens, Distance
//#define COORD_DIS_FP_100			xxx, 164	// Floating point, hundreds, Distance

#define COORD_LAR_FP_10				686, 164	// Floating point, tens, Width
//#define COORD_LAR_FP_100			xxx, 164	// Floating point, hundreds, Width

#define COORD_DIA_FP_10				760, 164	// Floating point, tens, Diameter
//#define COORD_DIA_FP_100			xxx, 164	// Floating point, hundreds, Diameter

	// LE DEFINIZIONI SEGUENTI SONO DEI DOPPIONI! CREDO SE NE POTREBBE FARE A MENO
#define COORD_DIS_FP_10_BLANK		612, 164	// Floating point blank, tens, OW
//#define COORD_DIS_FP_100_BLANK	xxx, 164	// Floating point blank, hundreds, OW
#define COORD_LAR_FP_10_BLANK		686, 164	// Floating point blank, tens, OW
//#define COORD_LAR_FP_100_BLANK	xxx, 164	// Floating point blank, hundreds, OW
#define COORD_DIA_FP_10_BLANK		760, 164	// Floating point blank, tens, OW
//#define COORD_DIA_FP_100_BLANK	xxx, 164	// Floating point blank, hundreds, OW


//
// Numbers: small font (used to display wheel dimensions)
//

//							 	 x, y
#define SMALL_NUMBER_DIM		20, 30
#define SMALL_NUMBER_FP_DIM	 	4,  4

// Small font numbers: src_page top-left coordinates
//								  x, y
#define SMALL_NUMBER_0			  0, 0, SMALL_NUMBER_DIM
#define SMALL_NUMBER_1			 22, 0, SMALL_NUMBER_DIM
#define SMALL_NUMBER_2			 44, 0, SMALL_NUMBER_DIM
#define SMALL_NUMBER_3			 66, 0, SMALL_NUMBER_DIM
#define SMALL_NUMBER_4			 88, 0, SMALL_NUMBER_DIM
#define SMALL_NUMBER_5			110, 0, SMALL_NUMBER_DIM
#define SMALL_NUMBER_6			132, 0, SMALL_NUMBER_DIM
#define SMALL_NUMBER_7			154, 0, SMALL_NUMBER_DIM
#define SMALL_NUMBER_8			176, 0, SMALL_NUMBER_DIM
#define SMALL_NUMBER_9			198, 82, SMALL_NUMBER_DIM
#define SMALL_NUMBER_BLANK		220, 0, SMALL_NUMBER_DIM

#define SMALL_NUMBER_FP			242, 0, SMALL_NUMBER_FP_DIM
#define SMALL_NUMBER_FP_BLANK	248, 0, SMALL_NUMBER_FP_DIM

//
// Utility definitions for quick clearing of left and right displays
//
#define DISPLAY_DIM		178, 101
#define LEFT_DISPLAY	22, 222, DISPLAY_DIM
#define RIGHT_DISPLAY	600, 222, DISPLAY_DIM

//
// Pure colors codified in RGB565 format
//

#define BLACK		0x0000
#define WHITE		0xFFFF
#define RED			0xF800
#define GREEN		0x07E0
#define BLUE		0x001F
#define YELLOW		0xFFE0		// RED + GREEN
#define MAGENTA		0xF81F		// RED + BLUE
#define CYAN		0x07FF		// GREEN + BLUE



#endif /* SYMBOL_H_ */
