library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
entity top_conMICO32 is
port(

		gpioPIO_OUT : out std_logic_vector(3 downto 0);
		u_spi_csn           : in std_logic;
		u_spi_clk           : in std_logic;
		u_spi_d             : in std_logic;
		u_spi_q             : out std_logic;
		------------------------------------------------
		rst_button : IN std_logic;
		tft_on_off_button : IN std_logic;
		ext_osc_clk : IN std_logic;
		spi_q : IN std_logic; 
		sdram_dq : INOUT std_logic_vector(15 downto 0);      
		sdram_clk : OUT std_logic;
		sdram_a : OUT std_logic_vector(11 downto 0);
		sdram_ba : OUT std_logic_vector(1 downto 0);
		sdram_cke : OUT std_logic;
		sdram_csn : OUT std_logic;
		sdram_rasn : OUT std_logic;
		sdram_casn : OUT std_logic;
		sdram_wen : OUT std_logic;
		sdram_dqm : OUT std_logic_vector(1 downto 0);
		spi_csn : OUT std_logic;
		spi_clk : OUT std_logic;
		spi_d : OUT std_logic;
		--tft_12v_bl_en : OUT std_logic;
		--tft_3v3_en : OUT std_logic;
		tft_clk : OUT std_logic;
		tft_hsync : OUT std_logic;
		tft_vsync : OUT std_logic;
		tft_dtmg : OUT std_logic;
		tft_red : OUT std_logic_vector(5 downto 0);
		tft_green : OUT std_logic_vector(5 downto 0);
		tft_blue : OUT std_logic_vector(5 downto 0);
		RDY : OUT std_logic;
		tastiPIO_IN : IN std_logic_vector (2 downto 0)

);
end top_conMICO32;

architecture top_conMICO32_a of top_conMICO32 is

--segnali mico32
signal clk_i   :  std_logic;
signal reset_n :  std_logic;
signal slave_passthruclk :  std_logic                                      ;
signal slave_passthrurst :  std_logic                                      ;
signal slave_passthruslv_adr :  std_logic_vector(31 downto 0)              ;
signal slave_passthruslv_master_data :  std_logic_vector(31 downto 0)      ;
signal slave_passthruslv_slave_data :  std_logic_vector(31 downto 0)        ;
signal slave_passthruslv_strb :  std_logic                                 ;
signal slave_passthruslv_cyc :  std_logic                                  ;
signal slave_passthruslv_ack :  std_logic                                   ;
signal slave_passthruslv_err :  std_logic                                   ;
signal slave_passthruslv_rty :  std_logic                                   ;
signal slave_passthruslv_sel :  std_logic_vector(3 downto 0)               ;
signal slave_passthruslv_we :  std_logic                                   ;
signal slave_passthruslv_bte :  std_logic_vector(1 downto 0)               ;
signal slave_passthruslv_cti :  std_logic_vector(2 downto 0)               ;
signal slave_passthruslv_lock :  std_logic                                 ;
signal slave_passthruintr_active_high :  std_logic                          ;


signal SPI_REGclk :  std_logic                                      ;
signal SPI_REGrst :  std_logic                                      ;
signal SPI_REGslv_adr :  std_logic_vector(31 downto 0)              ;
signal SPI_REGslv_master_data :  std_logic_vector(31 downto 0)      ;
signal SPI_REGslv_slave_data :  std_logic_vector(31 downto 0)        ;
signal SPI_REGslv_strb :  std_logic                                 ;
signal SPI_REGslv_cyc :  std_logic                                  ;
signal SPI_REGslv_ack :  std_logic                                   ;
signal SPI_REGslv_err :  std_logic                                   ;
signal SPI_REGslv_rty :  std_logic                                   ;
signal SPI_REGslv_sel :  std_logic_vector(3 downto 0)               ;
signal SPI_REGslv_we :  std_logic                                   ;
signal SPI_REGslv_bte :  std_logic_vector(1 downto 0)               ;
signal SPI_REGslv_cti :  std_logic_vector(2 downto 0)               ;
signal SPI_REGslv_lock :  std_logic                                 ;
signal SPI_REGintr_active_high :  std_logic                          ;

signal selezione_bebug :  STD_LOGIC;
signal mode8_1 :  STD_LOGIC;       
signal gpioPIO_OUT_int :  std_logic_vector(3 downto 0);
signal pageselPIO_OUT :  std_logic_vector(7 downto 0);
signal tastiPIO_IN_8bit :  std_logic_vector(7 downto 0);
component platform_PUR
   port(
     clk_i   : in std_logic;
     reset_n : in std_logic;
     gpioPIO_OUT : out std_logic_vector(3 downto 0)  ;                  
	 slave_passthruclk : out std_logic                                 ; 
     slave_passthrurst : out std_logic                                 ; 
     slave_passthruslv_adr : out std_logic_vector(31 downto 0)         ; 
     slave_passthruslv_master_data : out std_logic_vector(31 downto 0) ; 
     slave_passthruslv_slave_data : in std_logic_vector(31 downto 0)   ; 
     slave_passthruslv_strb : out std_logic                            ; 
     slave_passthruslv_cyc : out std_logic                             ; 
     slave_passthruslv_ack : in std_logic                              ; 
     slave_passthruslv_err : in std_logic                              ; 
     slave_passthruslv_rty : in std_logic                              ; 
     slave_passthruslv_sel : out std_logic_vector(3 downto 0)          ; 
     slave_passthruslv_we : out std_logic                              ; 
     slave_passthruslv_bte : out std_logic_vector(1 downto 0)          ; 
     slave_passthruslv_cti : out std_logic_vector(2 downto 0)          ; 
     slave_passthruslv_lock : out std_logic                            ; 
     slave_passthruintr_active_high : in std_logic   ;
	 pageselPIO_OUT :  out std_logic_vector(7 downto 0);
	 
	 SPI_REGclk : out std_logic                                 ; 
     SPI_REGrst : out std_logic                                 ; 
     SPI_REGslv_adr : out std_logic_vector(31 downto 0)         ; 
     SPI_REGslv_master_data : out std_logic_vector(31 downto 0) ; 
     SPI_REGslv_slave_data : in std_logic_vector(31 downto 0)   ; 
     SPI_REGslv_strb : out std_logic                            ; 
     SPI_REGslv_cyc : out std_logic                             ; 
     SPI_REGslv_ack : in std_logic                              ; 
     SPI_REGslv_err : in std_logic                              ; 
     SPI_REGslv_rty : in std_logic                              ; 
     SPI_REGslv_sel : out std_logic_vector(3 downto 0)          ; 
     SPI_REGslv_we : out std_logic                              ; 
     SPI_REGslv_bte : out std_logic_vector(1 downto 0)          ; 
     SPI_REGslv_cti : out std_logic_vector(2 downto 0)          ; 
     SPI_REGslv_lock : out std_logic                            ; 
     SPI_REGintr_active_high : in std_logic   	 ;
	 tastiPIO_IN : in std_logic_vector (7 downto 0)
      );
   end component;

   	COMPONENT tftsurfer_top
	PORT(
		rst_button : IN std_logic;
		tft_on_off_button : IN std_logic;
		ext_osc_clk : IN std_logic;
		spi_q : IN std_logic;
		WB_RST : IN std_logic;
		WB_CLK : IN std_logic;
		WB_CTI_I : IN std_logic_vector(2 downto 0);
		WB_BTE_I : IN std_logic_vector(1 downto 0);
		WB_ADR_I : IN std_logic_vector(31 downto 0);
		WB_DAT_I : IN std_logic_vector(31 downto 0);
		WB_SEL_I : IN std_logic_vector(3 downto 0);
		WB_WE_I : IN std_logic;
		WB_STB_I : IN std_logic;
		WB_CYC_I : IN std_logic;    
		sdram_dq : INOUT std_logic_vector(15 downto 0);      
		sdram_clk : OUT std_logic;
		sdram_a : OUT std_logic_vector(11 downto 0);
		sdram_ba : OUT std_logic_vector(1 downto 0);
		sdram_cke : OUT std_logic;
		sdram_csn : OUT std_logic;
		sdram_rasn : OUT std_logic;
		sdram_casn : OUT std_logic;
		sdram_wen : OUT std_logic;
		sdram_dqm : OUT std_logic_vector(1 downto 0);
		spi_csn : OUT std_logic;
		spi_clk : OUT std_logic;
		spi_d : OUT std_logic;
		tft_12v_bl_en : OUT std_logic;
		tft_3v3_en : OUT std_logic;
		tft_clk : OUT std_logic;
		tft_hsync : OUT std_logic;
		tft_vsync : OUT std_logic;
		tft_dtmg : OUT std_logic;
		tft_red : OUT std_logic_vector(5 downto 0);
		tft_green : OUT std_logic_vector(5 downto 0);
		tft_blue : OUT std_logic_vector(5 downto 0);
		WB_ACK_O : OUT std_logic;
		WB_DAT_O : OUT std_logic_vector(31 downto 0);
		WB_ERR_O : OUT std_logic;
		WB_RTY_O : OUT std_logic;
		selezione_bebug : IN STD_LOGIC;
		mode8_1			 : IN std_logic;
		pageselPIO_OUT :  in std_logic_vector(7 downto 0)
		);
	END COMPONENT;

   
begin
tastiPIO_IN_8bit  <=  "00000" & tastiPIO_IN(2 downto 0) ;
clk_i <= ext_osc_clk;
reset_n <= rst_button; 

lm32_inst : platform_PUR
port map (
   clk_i  							=> clk_i
   ,reset_n  						=> reset_n
   ,gpioPIO_OUT  					=> gpioPIO_OUT_int
   ,slave_passthruclk  				=> slave_passthruclk
   ,slave_passthrurst  				=> open
   ,slave_passthruslv_adr  			=> slave_passthruslv_adr
   ,slave_passthruslv_master_data  	=> slave_passthruslv_master_data
   ,slave_passthruslv_slave_data  	=> slave_passthruslv_slave_data
   ,slave_passthruslv_strb  		=> slave_passthruslv_strb
   ,slave_passthruslv_cyc  			=> slave_passthruslv_cyc
   ,slave_passthruslv_ack  			=> slave_passthruslv_ack
   ,slave_passthruslv_err  			=> slave_passthruslv_err
   ,slave_passthruslv_rty  			=> slave_passthruslv_rty
   ,slave_passthruslv_sel  			=> slave_passthruslv_sel
   ,slave_passthruslv_we  			=> slave_passthruslv_we
   ,slave_passthruslv_bte  			=> slave_passthruslv_bte
   ,slave_passthruslv_cti  			=> slave_passthruslv_cti
   ,slave_passthruslv_lock  		=> open
   ,slave_passthruintr_active_high 	=> '0'
   ,pageselPIO_OUT 					=> pageselPIO_OUT
   
		,SPI_REGrst  => open
		,SPI_REGslv_adr  => SPI_REGslv_adr
		,SPI_REGslv_master_data  => SPI_REGslv_master_data
		,SPI_REGslv_slave_data  => SPI_REGslv_slave_data
		,SPI_REGslv_strb  => SPI_REGslv_strb
		,SPI_REGslv_cyc  => SPI_REGslv_cyc
		,SPI_REGslv_ack  => SPI_REGslv_ack
		,SPI_REGslv_err  => SPI_REGslv_err
		,SPI_REGslv_rty  => SPI_REGslv_rty
		,SPI_REGslv_sel  => SPI_REGslv_sel
		,SPI_REGslv_we  => SPI_REGslv_we
		,SPI_REGslv_bte  => SPI_REGslv_bte
		,SPI_REGslv_cti  => SPI_REGslv_cti
		,SPI_REGslv_lock  => open
		,SPI_REGintr_active_high  => '0'
		, tastiPIO_IN =>  tastiPIO_IN_8bit
   );
   
 gpioPIO_OUT <=   gpioPIO_OUT_int;
 
  selezione_bebug <= '0' when gpioPIO_OUT_int = "1001" else '1';
  mode8_1 <= selezione_bebug;
   
  	controller_marco: tftsurfer_top PORT MAP(
		rst_button       	=> rst_button,
		tft_on_off_button	=> tft_on_off_button,
		ext_osc_clk      	=> ext_osc_clk,
		sdram_clk        	=> sdram_clk,
		sdram_dq         	=> sdram_dq,
		sdram_a          	=> sdram_a,
		sdram_ba         	=> sdram_ba,
		sdram_cke        	=> sdram_cke,
		sdram_csn        	=> sdram_csn,
		sdram_rasn       	=> sdram_rasn,
		sdram_casn       	=> sdram_casn,
		sdram_wen        	=> sdram_wen,
		sdram_dqm        	=> sdram_dqm,
		spi_csn          	=> spi_csn,
		spi_clk          	=> spi_clk,
		spi_d            	=> spi_d,
		spi_q            	=> spi_q,
		tft_12v_bl_en    	=> open,
		tft_3v3_en       	=> open,
		tft_clk          	=> tft_clk,
		tft_hsync        	=> tft_hsync,
		tft_vsync        	=> tft_vsync,
		tft_dtmg         	=> tft_dtmg,
		tft_red          	=> tft_red,
		tft_green        	=> tft_green,
		tft_blue         	=> tft_blue,
		WB_RST           	=> rst_button,
		WB_CLK           	=> slave_passthruclk,
		WB_CTI_I         	=> slave_passthruslv_cti,
		WB_BTE_I         	=> slave_passthruslv_bte,
		WB_ADR_I         	=> slave_passthruslv_adr,
		WB_DAT_I         	=> slave_passthruslv_master_data,
		WB_SEL_I         	=> slave_passthruslv_sel,
		WB_WE_I          	=> slave_passthruslv_we,
		WB_STB_I         	=> slave_passthruslv_strb,
		WB_CYC_I         	=> slave_passthruslv_cyc,
		WB_ACK_O         	=> slave_passthruslv_ack,
		WB_DAT_O         	=> slave_passthruslv_slave_data,
		WB_ERR_O         	=> slave_passthruslv_err,
		WB_RTY_O         	=> slave_passthruslv_rty,
		selezione_bebug		=> selezione_bebug,
		mode8_1			    => mode8_1,
		pageselPIO_OUT 		=> pageselPIO_OUT
				
	);

	SPI_top_INST: entity work.SPI_top
   port map (
      rst       => rst_button,
      clk       => clk_i,
      u_spi_csn => u_spi_csn,
      u_spi_clk => u_spi_clk,
      u_spi_d   => u_spi_d,
      u_spi_q   => u_spi_q,
	  ---------------------
      WB_RST    => rst_button,
      WB_CLK    => clk_i,
      WB_CTI_I  => SPI_REGslv_cti,
      WB_BTE_I  => SPI_REGslv_bte,
      WB_ADR_I  => SPI_REGslv_adr,
      WB_DAT_I  => SPI_REGslv_master_data,
      WB_SEL_I  => SPI_REGslv_sel,
      WB_WE_I   => SPI_REGslv_we,
      WB_STB_I  => SPI_REGslv_strb,
      WB_CYC_I  => SPI_REGslv_cyc,
      WB_ACK_O  => SPI_REGslv_ack,
      WB_DAT_O  => SPI_REGslv_slave_data,
      WB_ERR_O  => SPI_REGslv_err,
      WB_RTY_O  => SPI_REGslv_rty,
	  ----------------------
      RDY       => RDY);


	
	
end top_conMICO32_a;

