#-- Lattice Semiconductor Corporation Ltd.
#-- Synplify OEM project file

#device options
set_option -technology MACHXO2
set_option -part LCMXO2_7000HC
set_option -package FG484C
set_option -speed_grade -5

#compilation/mapping options
set_option -symbolic_fsm_compiler true
set_option -resource_sharing true

#use verilog 2001 standard option
set_option -vlog_std v2001

#map options
set_option -frequency 200
set_option -maxfan 100
set_option -auto_constrain_io 1
set_option -disable_io_insertion false
set_option -retiming false; set_option -pipe false
set_option -force_gsr false
set_option -compiler_compatible 1
set_option -dup false
set_option -frequency 1
set_option -default_enum_encoding default

#simulation options


#timing analysis options
set_option -num_critical_paths 3
set_option -num_startend_points 0

#automatic place and route (vendor) options
set_option -write_apr_constraint 0

#synplifyPro options
set_option -fix_gated_and_generated_clocks 1
set_option -update_models_cp 0
set_option -resolve_multiple_driver 1

#-- add_file options
add_file -vhdl {C:/lscc/diamond/2.1/cae_library/synthesis/vhdl/machxo2.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/periferica_SPI/SPI_top.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/periferica_SPI/memoria.vhd}

#-- top module name
set_option -top_module memoria

#-- set result format/file last
project -result_file {C:/work/project/artekit/periferica_SPI/prj/prj_prj.edi}

#-- error message log file
project -log_file {prj_prj.srf}

#-- set any command lines input by customer


#-- run Synplify with 'arrange HDL file'
project -run hdl_info_gen -fileorder
project -run
