
-- VHDL Test Bench Created from source file tft_timing_ctrl.vhd -- Tue Jan 08 18:23:05 2013

--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Lattice recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "source->import"
-- menu in the ispLEVER Project Navigator to import the testbench.
-- Then edit the user defined section below, adding code to generate the 
-- stimulus for your design.
-- 3) VHDL simulations will produce errors if there are Lattice FPGA library 
-- elements in your design that require the instantiation of GSR, PUR, and
-- TSALL and they are not present in the testbench. For more information see
-- the How To section of online help.  
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

	COMPONENT tft_timing_ctrl
	PORT(
		sys_rst : IN std_logic;
		sys_clk : IN std_logic;
		tft_clk : IN std_logic;
		sdram_test : IN std_logic;
		tft_test : IN std_logic;
		tft_bank : IN std_logic_vector(1 downto 0);
		tft_sect : IN std_logic_vector(2 downto 0);
		tft_sig_en : IN std_logic;
		tft_rgb_en : IN std_logic;
		tft_sdram_red : IN std_logic_vector(4 downto 0);
		tft_sdram_green : IN std_logic_vector(5 downto 0);
		tft_sdram_blue : IN std_logic_vector(4 downto 0);          
		tft_vtick : OUT std_logic;
		tft_row_start : OUT std_logic;
		tft_sdram_dtmg : OUT std_logic;
		tft_sdram_addr : OUT std_logic_vector(21 downto 0);
		tft_hsync : OUT std_logic;
		tft_vsync : OUT std_logic;
		tft_dtmg : OUT std_logic;
		tft_red : OUT std_logic_vector(7 downto 0);
		tft_green : OUT std_logic_vector(7 downto 0);
		tft_blue : OUT std_logic_vector(7 downto 0)
		);
	END COMPONENT;

	SIGNAL sys_rst :  std_logic;
	SIGNAL sys_clk :  std_logic;
	SIGNAL tft_clk :  std_logic;
	SIGNAL sdram_test :  std_logic;
	SIGNAL tft_test :  std_logic;
	SIGNAL tft_bank :  std_logic_vector(1 downto 0);
	SIGNAL tft_sect :  std_logic_vector(2 downto 0);
	SIGNAL tft_sig_en :  std_logic;
	SIGNAL tft_rgb_en :  std_logic;
	SIGNAL tft_vtick :  std_logic;
	SIGNAL tft_row_start :  std_logic;
	SIGNAL tft_sdram_dtmg :  std_logic;
	SIGNAL tft_sdram_addr :  std_logic_vector(21 downto 0);
	SIGNAL tft_sdram_red :  std_logic_vector(4 downto 0);
	SIGNAL tft_sdram_green :  std_logic_vector(5 downto 0);
	SIGNAL tft_sdram_blue :  std_logic_vector(4 downto 0);
	SIGNAL tft_hsync :  std_logic;
	SIGNAL tft_vsync :  std_logic;
	SIGNAL tft_dtmg :  std_logic;
	SIGNAL tft_red :  std_logic_vector(7 downto 0);
	SIGNAL tft_green :  std_logic_vector(7 downto 0);
	SIGNAL tft_blue :  std_logic_vector(7 downto 0);

BEGIN

-- Please check and add your generic clause manually
	uut: tft_timing_ctrl PORT MAP(
		sys_rst => sys_rst,
		sys_clk => sys_clk,
		tft_clk => tft_clk,
		sdram_test => sdram_test,
		tft_test => tft_test,
		tft_bank => tft_bank,
		tft_sect => tft_sect,
		tft_sig_en => tft_sig_en,
		tft_rgb_en => tft_rgb_en,
		tft_vtick => tft_vtick,
		tft_row_start => tft_row_start,
		tft_sdram_dtmg => tft_sdram_dtmg,
		tft_sdram_addr => tft_sdram_addr,
		tft_sdram_red => tft_sdram_red,
		tft_sdram_green => tft_sdram_green,
		tft_sdram_blue => tft_sdram_blue,
		tft_hsync => tft_hsync,
		tft_vsync => tft_vsync,
		tft_dtmg => tft_dtmg,
		tft_red => tft_red,
		tft_green => tft_green,
		tft_blue => tft_blue
	);


-- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN
      wait; -- will wait forever
   END PROCESS;
-- *** End Test Bench - User Defined Section ***

END;
