#-- Lattice Semiconductor Corporation Ltd.
#-- Synplify OEM project file

#device options
set_option -technology MACHXO2
set_option -part LCMXO2_7000HC
set_option -package TG144C
set_option -speed_grade -6

#compilation/mapping options
set_option -symbolic_fsm_compiler true
set_option -resource_sharing true

#use verilog 2001 standard option
set_option -vlog_std v2001

#map options
set_option -frequency 133
set_option -maxfan 100
set_option -auto_constrain_io 1
set_option -disable_io_insertion false
set_option -retiming false; set_option -pipe false
set_option -force_gsr false
set_option -compiler_compatible 0
set_option -dup false

set_option -default_enum_encoding default

#simulation options


#timing analysis options
set_option -num_critical_paths 3
set_option -num_startend_points 0

#automatic place and route (vendor) options
set_option -write_apr_constraint 0

#synplifyPro options
set_option -fix_gated_and_generated_clocks 1
set_option -update_models_cp 0
set_option -resolve_multiple_driver 1


#-- add_file options
set_option -include_path {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12}
add_file -verilog {C:/lscc/diamond/2.2/cae_library/synthesis/verilog/machxo2.v}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/monster_manager.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/pixel_addr_data_fifo.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/power_manager.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/sdram_ctrl.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/sdram_pkg.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/tft_on_off_button_ctrl.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/tft_pkg.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/tft_timing_ctrl.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/ipexpress/pixel_addr_fifo.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/ipexpress/pixel_data_fifo.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/ipexpress/pll_block.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/tft_pixel_rgb_pipeliner.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/ipexpress/pixel_rgb_fifo.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../img_mover_viewer.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../micro_emulator.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../spi_flash_reader.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../tftsurfer_demo.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../par_imager/img_spi_sector_rom.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/wb_add_fifo.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/wb_interface.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/wb_data_fifo.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src/tftsurfer_top.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../../mico32_ver0/top_conMICO32vhd.vhd}
add_file -verilog {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../../mico32_ver0/platform/soc/platform.v}
add_file -verilog {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../../mico32_ver0/platform/soc/platform_PUR.v}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src_spi/memoria.vhd}
add_file -vhdl -lib "work" {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/../src_spi/SPI_top.vhd}
add_file -verilog {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/tftsurfer/cancellami.v}

#-- top module name
set_option -top_module top_conMICO32

#-- set result format/file last
project -result_file {C:/work/project/artekit/tftsurfer_demo_v003_versione_EAS_TFTSURFER_demo_OSC_DELL_CLKOP/par_d12/tftsurfer/tftsurfer_tftsurfer.edi}

#-- error message log file
project -log_file {tftsurfer_tftsurfer.srf}

#-- set any command lines input by customer


#-- run Synplify with 'arrange HDL file'
project -run hdl_info_gen -fileorder
project -run
