
-- VHDL Test Bench Created from source file tftsurfer_top.vhd -- Wed Jan 30 17:29:42 2013

--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Lattice recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "source->import"
-- menu in the ispLEVER Project Navigator to import the testbench.
-- Then edit the user defined section below, adding code to generate the 
-- stimulus for your design.
-- 3) VHDL simulations will produce errors if there are Lattice FPGA library 
-- elements in your design that require the instantiation of GSR, PUR, and
-- TSALL and they are not present in the testbench. For more information see
-- the How To section of online help.  
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
USE work.BFM_func.all;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

	COMPONENT tftsurfer_top
	PORT(
		rst_button : IN std_logic;
		tft_on_off_button : IN std_logic;
		ext_osc_clk : IN std_logic;
		spi_q : IN std_logic;
		WB_RST : IN std_logic;
		WB_CLK : IN std_logic;
		WB_CTI_I : IN std_logic_vector(2 downto 0);
		WB_BTE_I : IN std_logic_vector(1 downto 0);
		WB_ADR_I : IN std_logic_vector(31 downto 0);
		WB_DAT_I : IN std_logic_vector(31 downto 0);
		WB_SEL_I : IN std_logic_vector(3 downto 0);
		WB_WE_I : IN std_logic;
		WB_STB_I : IN std_logic;
		WB_CYC_I : IN std_logic;    
		sdram_dq : INOUT std_logic_vector(15 downto 0);      
		sdram_clk : OUT std_logic;
		sdram_a : OUT std_logic_vector(11 downto 0);
		sdram_ba : OUT std_logic_vector(1 downto 0);
		sdram_cke : OUT std_logic;
		sdram_csn : OUT std_logic;
		sdram_rasn : OUT std_logic;
		sdram_casn : OUT std_logic;
		sdram_wen : OUT std_logic;
		sdram_dqm : OUT std_logic_vector(1 downto 0);
		spi_csn : OUT std_logic;
		spi_clk : OUT std_logic;
		spi_d : OUT std_logic;
		tft_12v_bl_en : OUT std_logic;
		tft_3v3_en : OUT std_logic;
		tft_clk : OUT std_logic;
		tft_hsync : OUT std_logic;
		tft_vsync : OUT std_logic;
		tft_dtmg : OUT std_logic;
		tft_red : OUT std_logic_vector(5 downto 0);
		tft_green : OUT std_logic_vector(5 downto 0);
		tft_blue : OUT std_logic_vector(5 downto 0);
		WB_ACK_O : OUT std_logic;
		WB_DAT_O : OUT std_logic_vector(31 downto 0);
		WB_ERR_O : OUT std_logic;
		WB_RTY_O : OUT std_logic
		);
	END COMPONENT;

	SIGNAL rst_button :  std_logic;
	SIGNAL tft_on_off_button :  std_logic;
	SIGNAL ext_osc_clk :  std_logic;
	SIGNAL sdram_clk :  std_logic;
	SIGNAL sdram_dq :  std_logic_vector(15 downto 0);
	SIGNAL sdram_a :  std_logic_vector(11 downto 0);
	SIGNAL sdram_ba :  std_logic_vector(1 downto 0);
	SIGNAL sdram_cke :  std_logic;
	SIGNAL sdram_csn :  std_logic;
	SIGNAL sdram_rasn :  std_logic;
	SIGNAL sdram_casn :  std_logic;
	SIGNAL sdram_wen :  std_logic;
	SIGNAL sdram_dqm :  std_logic_vector(1 downto 0);
	SIGNAL spi_csn :  std_logic;
	SIGNAL spi_clk :  std_logic;
	SIGNAL spi_d :  std_logic;
	SIGNAL spi_q :  std_logic;
	SIGNAL tft_12v_bl_en :  std_logic;
	SIGNAL tft_3v3_en :  std_logic;
	SIGNAL tft_clk :  std_logic;
	SIGNAL tft_hsync :  std_logic;
	SIGNAL tft_vsync :  std_logic;
	SIGNAL tft_dtmg :  std_logic;
	SIGNAL tft_red :  std_logic_vector(5 downto 0);
	SIGNAL tft_green :  std_logic_vector(5 downto 0);
	SIGNAL tft_blue :  std_logic_vector(5 downto 0);
	SIGNAL WB_RST :  std_logic;
	SIGNAL WB_CLK :  std_logic;
	SIGNAL WB_CTI_I :  std_logic_vector(2 downto 0);
	SIGNAL WB_BTE_I :  std_logic_vector(1 downto 0);
	SIGNAL WB_ADR_I :  std_logic_vector(31 downto 0);
	SIGNAL WB_DAT_I :  std_logic_vector(31 downto 0);
	SIGNAL WB_SEL_I :  std_logic_vector(3 downto 0);
	SIGNAL WB_WE_I :  std_logic;
	SIGNAL WB_STB_I :  std_logic;
	SIGNAL WB_CYC_I :  std_logic;
	SIGNAL WB_ACK_O :  std_logic;
	SIGNAL WB_DAT_O :  std_logic_vector(31 downto 0);
	SIGNAL WB_ERR_O :  std_logic;
	SIGNAL WB_RTY_O :  std_logic;
	
	SIGNAL STB_I :  std_logic;
	SIGNAL CYC_I :  std_logic;
	SIGNAL ACK_O :  std_logic;

BEGIN

-- Please check and add your generic clause manually
	uut: tftsurfer_top PORT MAP(
		rst_button => rst_button,
		tft_on_off_button => tft_on_off_button,
		ext_osc_clk => ext_osc_clk,
		sdram_clk => sdram_clk,
		sdram_dq => sdram_dq,
		sdram_a => sdram_a,
		sdram_ba => sdram_ba,
		sdram_cke => sdram_cke,
		sdram_csn => sdram_csn,
		sdram_rasn => sdram_rasn,
		sdram_casn => sdram_casn,
		sdram_wen => sdram_wen,
		sdram_dqm => sdram_dqm,
		spi_csn => spi_csn,
		spi_clk => spi_clk,
		spi_d => spi_d,
		spi_q => spi_q,
		tft_12v_bl_en => tft_12v_bl_en,
		tft_3v3_en => tft_3v3_en,
		tft_clk => tft_clk,
		tft_hsync => tft_hsync,
		tft_vsync => tft_vsync,
		tft_dtmg => tft_dtmg,
		tft_red => tft_red,
		tft_green => tft_green,
		tft_blue => tft_blue,
		WB_RST => WB_RST,
		WB_CLK => WB_CLK,
		WB_CTI_I => WB_CTI_I,
		WB_BTE_I => WB_BTE_I,
		WB_ADR_I => WB_ADR_I,
		WB_DAT_I => WB_DAT_I,
		WB_SEL_I => WB_SEL_I,
		WB_WE_I => WB_WE_I,
		WB_STB_I => WB_STB_I,
		WB_CYC_I => WB_CYC_I,
		WB_ACK_O => WB_ACK_O,
		WB_DAT_O => WB_DAT_O,
		WB_ERR_O => WB_ERR_O,
		WB_RTY_O => WB_RTY_O
	);
process
begin
WB_RST <= '1';
wait for 100 ns;
WB_RST <= '0';
wait;
end process;
rst_button <= not WB_RST;

process
begin
WB_CLK <= '1';
wait for 20 ns;
WB_CLK <= '0';
wait for 20 ns;
end process;

process
begin
ext_osc_clk <= '1';
wait for 10 ns;
ext_osc_clk <= '0';
wait for 10 ns;
end process;

-- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN
   WB_STB_I <= '0';
   WB_CYC_I <= '0';
   WB_WE_I <= '1';
   wait for 500 ns;
   	s_write ( X"00000004", X"00112233", "1111", WB_ADR_I, WB_DAT_I, WB_WE_I, WB_STB_I, WB_CYC_I, WB_CTI_I, WB_SEL_I, WB_BTE_I, WB_DAT_O, WB_ACK_O, WB_CLK, WB_RST); 
	s_read  ( X"00000004", X"00112233", "1111", WB_ADR_I, WB_DAT_I, WB_WE_I, WB_STB_I, WB_CYC_I, WB_CTI_I, WB_SEL_I, WB_BTE_I, WB_DAT_O, WB_ACK_O, WB_CLK, WB_RST); 
      wait; -- will wait forever
   END PROCESS;
-- *** End Test Bench - User Defined Section ***



END;
