#-- Lattice Semiconductor Corporation Ltd.
#-- Synplify OEM project file

#device options
set_option -technology MACHXO2
set_option -part LCMXO2_1200HC
set_option -package TG144C
set_option -speed_grade -6

#compilation/mapping options
set_option -symbolic_fsm_compiler true
set_option -resource_sharing true

#use verilog 2001 standard option
set_option -vlog_std v2001

#map options
set_option -frequency 200
set_option -fanout_limit 100
set_option -auto_constrain_io true
set_option -disable_io_insertion false
set_option -retiming false; set_option -pipe false
set_option -force_gsr false
set_option -compiler_compatible true
set_option -dup false
set_option -frequency 1

set_option -default_enum_encoding default

#simulation options
set_option -write_verilog true
set_option -write_vhdl true

#timing analysis options
set_option -num_critical_paths 3
set_option -num_startend_points 0

#automatic place and route (vendor) options
set_option -write_apr_constraint 0

#synplifyPro options
set_option -fixgatedclocks 3
set_option -fixgeneratedclocks 3
set_option -update_models_cp 0
set_option -resolve_multiple_driver 1

#-- add_file options
add_file -vhdl {C:/lscc/diamond/1.2/cae_library/synthesis/vhdl/machxo2.vhd}
add_file -vhdl -lib "work" {C:/work/LSCC/TFTSurfer/VHDL/tftsurfer_demo_v001/par_imager/img_spi_sector_rom.vhd}
add_file -vhdl -lib "work" {C:/work/LSCC/TFTSurfer/VHDL/tftsurfer_demo_v001/par_imager/../img_mover_viewer.vhd}
add_file -vhdl -lib "work" {C:/work/LSCC/TFTSurfer/VHDL/tftsurfer_demo_v001/micro_emulator.vhd}
add_file -vhdl -lib "work" {C:/work/LSCC/TFTSurfer/VHDL/tftsurfer_demo_v001/spi_flash_reader.vhd}
add_file -vhdl -lib "work" {C:/work/LSCC/TFTSurfer/VHDL/tftsurfer_demo_v001/tftsurfer_demo.vhd}

#-- top module name
set_option -top_module tftsurfer_demo

#-- set result format/file last
project -result_file {C:/work/LSCC/TFTSurfer/VHDL/tftsurfer_demo_v001/par_imager/image/image_image.edi}

#-- error message log file
project -log_file {image_image.srf}

#-- set any command lines input by customer


#-- run Synplify with 'arrange HDL file'
project -run hdl_info_gen -fileorder
project -run
