LIBRARY ieee;
USE ieee.std_logic_1164.all;

PACKAGE BFM_func IS

procedure s_write (
		address : in std_logic_vector(31 downto 0);
		data : in std_logic_vector(31 downto 0); 
		sel   : in std_logic_vector(3 downto 0); 
	signal ADR_I  : out std_logic_vector(31 downto 0);
	signal DAT_I  : out std_logic_vector(31 downto 0);
	signal WE_I   : out std_logic;
	signal STB_I  : out std_logic;
	signal CYC_I  : out std_logic;
	signal CTI_I  : out std_logic_vector(2 downto 0);
	signal SEL_I  : out std_logic_vector(3 downto 0);
	signal BTE_I  : out std_logic_vector(1 downto 0);
	signal DAT_O : in std_logic_vector(31 downto 0);
	signal ACK_O : in std_logic;
	signal CLK_I : in std_logic;
	signal RST_I : in std_logic );



procedure s_read (
		address : in std_logic_vector(31 downto 0);
		data : in std_logic_vector(31 downto 0); 
		sel   : in std_logic_vector(3 downto 0); 
	signal ADR_I  : out std_logic_vector(31 downto 0);
	signal DAT_I  : out std_logic_vector(31 downto 0);
	signal WE_I   : out std_logic;
	signal STB_I  : out std_logic;
	signal CYC_I  : out std_logic;
	signal CTI_I  : out std_logic_vector(2 downto 0);
	signal SEL_I  : out std_logic_vector(3 downto 0);
	signal BTE_I  : out std_logic_vector(1 downto 0);
	signal DAT_O : in std_logic_vector(31 downto 0);
	signal ACK_O : in std_logic;
	signal CLK_I : in std_logic;
	signal RST_I : in std_logic );

END BFM_func;
PACKAGE BODY BFM_func IS	

procedure s_write (
		address : in std_logic_vector(31 downto 0);
		data : in std_logic_vector(31 downto 0); 
		sel   : in std_logic_vector(3 downto 0); 
	signal ADR_I  : out std_logic_vector(31 downto 0);
	signal DAT_I  : out std_logic_vector(31 downto 0);
	signal WE_I   : out std_logic;
	signal STB_I  : out std_logic;
	signal CYC_I  : out std_logic;
	signal CTI_I  : out std_logic_vector(2 downto 0);
	signal SEL_I  : out std_logic_vector(3 downto 0);
	signal BTE_I  : out std_logic_vector(1 downto 0);
	signal DAT_O : in std_logic_vector(31 downto 0);
	signal ACK_O : in std_logic;	
	signal CLK_I : in std_logic;
	signal RST_I : in std_logic ) is
	
begin
ADR_I <= (others => '0');
DAT_I <= (others => 'Z');
WE_I  <= '0';
STB_I <= '0';
CYC_I <= '0';
CTI_I <= (others => '0');
SEL_I <= (others => '0');
BTE_I <= (others => '0');
wait until (CLK_I'event and CLK_I='1');
ADR_I <= address; 
DAT_I <= data;
WE_I  <= '1';
STB_I <= '1';
CYC_I <= '1';
CTI_I <= "000";
SEL_I <= sel;
BTE_I <= "00";
wait until (ACK_O'event and ACK_O='1');
wait until (CLK_I'event and CLK_I='1');
ADR_I <= (others => '0');
DAT_I <= (others => '0');
WE_I  <= '0';
STB_I <= '0';
CYC_I <= '0';
CTI_I <= (others => '0');
SEL_I <= (others => '0');
BTE_I <= (others => '0');
wait until (CLK_I'event and CLK_I='1');
end s_write;

procedure s_read (
		address : in std_logic_vector(31 downto 0);
		data : in std_logic_vector(31 downto 0); 
		sel   : in std_logic_vector(3 downto 0); 
	signal ADR_I  : out std_logic_vector(31 downto 0);
	signal DAT_I  : out std_logic_vector(31 downto 0);
	signal WE_I   : out std_logic;
	signal STB_I  : out std_logic;
	signal CYC_I  : out std_logic;
	signal CTI_I  : out std_logic_vector(2 downto 0);
	signal SEL_I  : out std_logic_vector(3 downto 0);
	signal BTE_I  : out std_logic_vector(1 downto 0);
	signal DAT_O : in std_logic_vector(31 downto 0);
	signal ACK_O : in std_logic;	
	signal CLK_I : in std_logic;
	signal RST_I : in std_logic ) is
	
begin
ADR_I <= (others => '0');
DAT_I <= (others => '0');
WE_I  <= '0';
STB_I <= '0';
CYC_I <= '0';
CTI_I <= (others => '0');
SEL_I <= (others => '0');
BTE_I <= (others => '0');
wait until (CLK_I'event and CLK_I='1');
ADR_I <= address;
WE_I  <= '0';
STB_I <= '1';
CYC_I <= '1';
CTI_I <= "000";
SEL_I <= sel;
BTE_I <= "00";
wait until (ACK_O'event and ACK_O='1');
wait until (CLK_I'event and CLK_I='1');
ADR_I <= (others => '0');
DAT_I <= (others => '0');
WE_I  <= '0';
STB_I <= '0';
CYC_I <= '0';
CTI_I <= (others => '0');
SEL_I <= (others => '0');
BTE_I <= (others => '0');
wait until (CLK_I'event and CLK_I='1');
end s_read;

END BFM_func;