
-- VHDL Test Bench Created from source file tftsurfer_top.vhd -- Fri Sep 16 18:50:59 2011

--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Lattice recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "source->import"
-- menu in the ispLEVER Project Navigator to import the testbench.
-- Then edit the user defined section below, adding code to generate the 
-- stimulus for your design.
-- 3) VHDL simulations will produce errors if there are Lattice FPGA library 
-- elements in your design that require the instantiation of GSR, PUR, and
-- TSALL and they are not present in the testbench. For more information see
-- the How To section of online help.  
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

component mt48lc4m16a2 
    generic(
        addr_bits       : integer := 12;
        data_bits       : integer := 16;
        col_bits        : integer := 8;
        mem_sizes       : integer := 1048575;
        -- tAC             : real    := 6.000000;
        -- tHZ             : real    := 6.000000;
        -- tOH             : real    := 3.000000;
        -- tMRD            : real    := 2.000000;
        -- tRAS            : real    := 44.000000;
        -- tRC             : real    := 66.000000;
        -- tRCD            : real    := 20.000000;
        -- tRFC            : real    := 66.000000;
        -- tRP             : real    := 20.000000;
        -- tRRD            : real    := 15.000000;
        -- tWRa            : real    := 7.500000;
        -- tWRm            : real    := 15.000000
        tAC             : real    :=   5.4;
        tHZ             : real    :=   5.4;
        tOH             : real    :=   3.0;
        tMRD            : real    :=   2.0;
        tRAS            : real    :=  37.0;
        tRC             : real    :=  60.0;
        tRCD            : real    :=  15.0;
        tRFC            : real    :=  66.0;
        tRP             : real    :=  15.0;
        tRRD            : real    :=  14.0;
        tWRa            : real    :=   7.0;
        tWRm            : real    :=  14.0
   );
    port(
        Dq              : inout std_logic_vector(15 downto 0);
        Addr            : in    std_logic_vector;
        Ba              : in    std_logic_vector(1 downto 0);
        Clk             : in    std_logic;
        Cke             : in    std_logic;
        Cs_n            : in    std_logic;
        Ras_n           : in    std_logic;
        Cas_n           : in    std_logic;
        We_n            : in    std_logic;
        Dqm             : in    std_logic_vector(1 downto 0)
    );
end component;

	COMPONENT tftsurfer_top
	PORT(
		rst_button : IN std_logic;
		tft_on_off_button : IN std_logic;
		ext_osc_clk : IN std_logic;    
		sdram_dq : INOUT std_logic_vector(15 downto 0);      
		test_pt1 : OUT std_logic;
		test_pt2 : OUT std_logic;
		test_pt3 : OUT std_logic;
		test_pt4 : OUT std_logic;
		test_pt5 : OUT std_logic;
		sdram_clk : OUT std_logic;
		sdram_a : OUT std_logic_vector(11 downto 0);
		sdram_ba : OUT std_logic_vector(1 downto 0);
		sdram_cke : OUT std_logic;
		sdram_csn : OUT std_logic;
		sdram_rasn : OUT std_logic;
		sdram_casn : OUT std_logic;
		sdram_wen : OUT std_logic;
		sdram_dqm : OUT std_logic_vector(1 downto 0);
		tft_12v_bl_en : OUT std_logic;
		tft_3v3_en : OUT std_logic;
		tft_scan_dir : OUT std_logic;
		tft_6bit_mode : OUT std_logic;
		tft_dimming : OUT std_logic;
		tft_clk_out : OUT std_logic;
		tft_data0 : OUT std_logic;
		tft_data1 : OUT std_logic;
		tft_data2 : OUT std_logic;
		tft_data3 : OUT std_logic
		);
	END COMPONENT;

	SIGNAL rst_button :  std_logic := '0';
	SIGNAL tft_on_off_button :  std_logic := '1';
	SIGNAL ext_osc_clk :  std_logic := '1';
	SIGNAL test_pt1 :  std_logic;
	SIGNAL test_pt2 :  std_logic;
	SIGNAL test_pt3 :  std_logic;
	SIGNAL test_pt4 :  std_logic;
	SIGNAL test_pt5 :  std_logic;
	SIGNAL sdram_clk :  std_logic;
	SIGNAL sdram_dq :  std_logic_vector(15 downto 0);
	SIGNAL sdram_a :  std_logic_vector(11 downto 0);
	SIGNAL sdram_ba :  std_logic_vector(1 downto 0);
	SIGNAL sdram_cke :  std_logic;
	SIGNAL sdram_csn :  std_logic;
	SIGNAL sdram_rasn :  std_logic;
	SIGNAL sdram_casn :  std_logic;
	SIGNAL sdram_wen :  std_logic;
	SIGNAL sdram_dqm :  std_logic_vector(1 downto 0);
	SIGNAL tft_12v_bl_en :  std_logic;
	SIGNAL tft_3v3_en :  std_logic;
	SIGNAL tft_scan_dir :  std_logic;
	SIGNAL tft_6bit_mode :  std_logic;
	SIGNAL tft_dimming :  std_logic;
	SIGNAL tft_clk_out :  std_logic;
	SIGNAL tft_data0 :  std_logic;
	SIGNAL tft_data1 :  std_logic;
	SIGNAL tft_data2 :  std_logic;
	SIGNAL tft_data3 :  std_logic;

BEGIN

	ext_osc_clk <= not ext_osc_clk after 12.5 ns;

-- Please check and add your generic clause manually
	uut: tftsurfer_top PORT MAP(
		rst_button => rst_button,
		tft_on_off_button => tft_on_off_button,
		ext_osc_clk => ext_osc_clk,
		test_pt1 => test_pt1,
		test_pt2 => test_pt2,
		test_pt3 => test_pt3,
		test_pt4 => test_pt4,
		test_pt5 => test_pt5,
		sdram_clk => sdram_clk,
		sdram_dq => sdram_dq,
		sdram_a => sdram_a,
		sdram_ba => sdram_ba,
		sdram_cke => sdram_cke,
		sdram_csn => sdram_csn,
		sdram_rasn => sdram_rasn,
		sdram_casn => sdram_casn,
		sdram_wen => sdram_wen,
		sdram_dqm => sdram_dqm,
		tft_12v_bl_en => tft_12v_bl_en,
		tft_3v3_en => tft_3v3_en,
		tft_scan_dir => tft_scan_dir,
		tft_6bit_mode => tft_6bit_mode,
		tft_dimming => tft_dimming,
		tft_clk_out => tft_clk_out,
		tft_data0 => tft_data0,
		tft_data1 => tft_data1,
		tft_data2 => tft_data2,
		tft_data3 => tft_data3
	);

MT48LC4M16A2_INST: mt48lc4m16a2
	generic map(
        addr_bits       => 12,
        data_bits       => 16,
        col_bits        => 8,
        mem_sizes       => 1048575,
        tAC             =>   5.4,
        tHZ             =>   5.4,
        tOH             =>   3.0,
        tMRD            =>   2.0,
        tRAS            =>  37.0,
        tRC             =>  60.0,
        tRCD            =>  15.0,
        tRFC            =>  66.0,
        tRP             =>  15.0,
        tRRD            =>  14.0,
        tWRa            =>   7.0,
        tWRm            =>  14.0
	)
    port map(
        Dq              => sdram_dq,
        Addr            => sdram_a,
        Ba              => sdram_ba,
        Clk             => sdram_clk,
        Cke             => sdram_cke,
        Cs_n            => sdram_csn,
        Ras_n           => sdram_rasn,
        Cas_n           => sdram_casn,
        We_n            => sdram_wen,
        Dqm             => sdram_dqm
    );


-- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN
		rst_button <= '0';
		tft_on_off_button <= '1';
		--
		wait for 100 ns;
		--
		rst_button <= '1';
		--
		wait for 30 us;
		--
		tft_on_off_button <= '0';
		--
		wait for 10 us;
		--
		tft_on_off_button <= '1';
		--
		-- wait for 30 us;
		-- --
		-- tft_on_off_button <= '0';
		-- --
		-- wait for 10 us;
		-- --
		-- tft_on_off_button <= '1';
		-- --
		-- wait for 30 us;
		-- --
		-- tft_on_off_button <= '0';
		-- --
		-- wait for 10 us;
		-- --
		-- tft_on_off_button <= '1';
		--
      wait; -- will wait forever
		--
   END PROCESS;
-- *** End Test Bench - User Defined Section ***

END;
